<?php
namespace Opencart\Admin\Model\Extension\IdPaymentAlfabankBY\Payment;
class AlfabankBYPayment extends \Opencart\System\Engine\Model {
public function install(): void {
$this->db->query("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "alfabankby_order` (
`gateway_order_id` int(11) NOT NULL AUTO_INCREMENT,
`gateway_order_reference` varchar(64),
`order_id` int(11) NOT NULL,
`currency` varchar(3),
`order_amount` decimal(15,4) NOT NULL COMMENT 'Order amount',
`order_amount_deposited` decimal(15,4) NOT NULL COMMENT 'Order deposited amount',
`order_amount_refunded` decimal(15,4) NOT NULL COMMENT 'Order refunded amount',
`status_deposited` tinyint(1) NOT NULL DEFAULT 0,
`status_reversed` tinyint(1) NOT NULL DEFAULT 0,
`status_refunded` tinyint(1) NOT NULL DEFAULT 0,
`status` tinyint(1) NOT NULL DEFAULT 0,
`date_added` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
`date_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
PRIMARY KEY (`gateway_order_id`),
KEY `order_id` (`order_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci
");
$this->db->query("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "alfabankby_payment` (
`alfabankby_payment_id` int(11) NOT NULL AUTO_INCREMENT,
`customer_id` int(11) NOT NULL,
`card_name` varchar(64) NOT NULL,
`card_number` varchar(64) NOT NULL,
`card_expire_month` varchar(64) NOT NULL,
`card_expire_year` varchar(64) NOT NULL,
`card_cvv` varchar(3) NOT NULL,
`date_added` datetime NOT NULL,
PRIMARY KEY (`alfabankby_payment_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci
");
$this->db->query("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "alfabankby_payment_report` (
`alfabankby_payment_report_id` int(11) NOT NULL AUTO_INCREMENT,
`order_id` int(11) NOT NULL,
`card_name` varchar(64) NOT NULL,
`amount` decimal(15,4) NOT NULL,
`response` text NOT NULL,
`order_status_id` int(11) NOT NULL,
`date_added` datetime NOT NULL,
PRIMARY KEY (`alfabankby_payment_report_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci
");
}
public function getGatewayOrder($order_id) {
$table_name = DB_PREFIX . "alfabankby_order";
$table_check = $this->db->query("SHOW TABLES LIKE '" . $table_name . "'");
if ($table_check->num_rows) {
$result = $this->db->query("SELECT * FROM `" . $table_name . "` WHERE order_id = " . (int)$order_id . " LIMIT 1");
return $result->row;
} else {
return null;
}
}
public function updateGatewayOrder($order_id, $data) {
$sql = "UPDATE `" . DB_PREFIX . "alfabankby_order` SET ";
$sql_data = array();
if (isset($data['order_amount_deposited'])) {
$sql_data[] = "`order_amount_deposited` = '" . (float)$data['order_amount_deposited'] . "'";
}
if (isset($data['order_amount_refunded'])) {
$sql_data[] = "`order_amount_refunded` = '" . (float)$data['order_amount_refunded'] . "'";
}
if (isset($data['status_deposited'])) {
$sql_data[] = "`status_deposited` = " . (int)$data['status_deposited'];
}
if (isset($data['status_reversed'])) {
$sql_data[] = "`status_reversed` = " . (int)$data['status_reversed'];
}
if (isset($data['status_refunded'])) {
$sql_data[] = "`status_refunded` = " . (int)$data['status_refunded'];
}
if (isset($data['status'])) {
$sql_data[] = "`status` = " . (int)$data['status'];
}
$sql_data[] = "`date_updated` = NOW()";
$sql .= implode(', ', $sql_data);
$sql .= " WHERE `order_id` = " . (int)$order_id;
$this->db->query($sql);
}
public function uninstall(): void {
$this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "alfabankby_order`");
$this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "alfabankby_payment`");
$this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "alfabankby_payment_report`");
}
public function addAlfabankBYPayment(array $data): void {
$this->db->query("INSERT INTO `" . DB_PREFIX . "customer_payment` SET
`customer_id` = '" . (int)$this->customer->getId() . "',
`name` = '" . (int)$this->customer->getId() . "',
`image` = '" . $this->db->escape($data['image']) . "',
`type` = '" . $this->db->escape($data['type']) . "',
`extension` = '" . $this->db->escape($data['extension']) . "',
`code` = '" . $this->db->escape($data['code']) . "',
`token` = '" . $this->db->escape($data['token']) . "',
`date_expire` = '" . $this->db->escape($data['date_expire']) . "',
`default` = '" . (bool)$data['default'] . "',
`status` = '1',
`date_added` = NOW()");
}
public function deleteAlfabankBYPayment(int $customer_payment_id): void {
$this->db->query("DELETE FROM `" . DB_PREFIX . "customer_payment` WHERE `customer_id` = '" . (int)$this->customer->getId() . "' AND `customer_payment_id` = '" . (int)$customer_payment_id . "'");
}
public function getReports(int $download_id, int $start = 0, int $limit = 10): array {
if ($start < 0) {
$start = 0;
}
if ($limit < 1) {
$limit = 10;
}
$query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "alfabankby_payment_report` ORDER BY `date_added` ASC LIMIT " . (int)$start . "," . (int)$limit);
return $query->rows;
}
public function getTotalReports(): int {
$query = $this->db->query("SELECT COUNT(*) AS `total` FROM `" . DB_PREFIX . "alfabankby_payment_report`");
if ($query->num_rows) {
return $query->row['total'];
} else {
return 0;
}
}
}
