<?php
namespace Opencart\Catalog\Model\Extension\IdPaymentAlfabankBY\Payment;
class AlfabankBYPayment extends \Opencart\System\Engine\Model {
public function getMethods(array $address): array {
$this->load->language('extension/id_payment_alfabankby/payment/alfabankby_payment');
if (!$this->config->get('config_checkout_payment_address')) {
$status = true;
} elseif (!$this->config->get('payment_alfabankby_payment_geo_zone_id')) {
$status = true;
} else {
$query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "zone_to_geo_zone` WHERE `geo_zone_id` = '" . (int)$this->config->get('payment_alfabankby_payment_geo_zone_id') . "' AND `country_id` = '" . (int)$address['country_id'] . "' AND (`zone_id` = '" . (int)$address['zone_id'] . "' OR `zone_id` = '0')");
if ($query->num_rows) {
$status = true;
} else {
$status = false;
}
}
$method_data = [];
if ($status) {
$option_data = [];
$option_data['alfabankby_payment'] = [
'code' => 'alfabankby_payment.alfabankby_payment',
'name'       => $this->config->get('payment_alfabankby_payment_method_title'),
];
$results = $this->getAlfabankBYPayments($this->customer->getId());
foreach ($results as $result) {
$option_data[$result['alfabankby_payment_id']] = [
'code' => 'alfabankby_payment.' . $result['alfabankby_payment_id'],
'name' => $this->language->get('text__use') . ' ' . $result['card_number']
];
}
$method_data = [
'code'       => 'alfabankby_payment',
'name'       => $this->config->get('payment_alfabankby_payment_method_title'),
'option'     => $option_data,
'sort_order' => $this->config->get('payment_alfabankby_payment_sort_order')
];
}
return $method_data;
}
public function getAlfabankBYPayment(int $customer_id, int $alfabankby_payment_id) {
$query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "alfabankby_payment` WHERE `customer_id` = '" . (int)$customer_id . "' AND `alfabankby_payment_id` = '" . (int)$alfabankby_payment_id . "'");
return $query->row;
}
public function getAlfabankBYPayments(int $customer_id): array {
$query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "alfabankby_payment` WHERE `customer_id` = '" . (int)$customer_id . "'");
return $query->rows;
}
public function addAlfabankBYPayment(int $customer_id, array $data): void {
$this->db->query("INSERT INTO `" . DB_PREFIX . "alfabankby_payment` SET `customer_id` = '" . (int)$customer_id . "', `card_name` = '" . $this->db->escape($data['card_name']) . "', `card_number` = '" . $this->db->escape($data['card_number']) . "', `card_expire_month` = '" . $this->db->escape($data['card_expire_month']) . "', `card_expire_year` = '" . $this->db->escape($data['card_expire_year']) . "', `card_cvv` = '" . $this->db->escape($data['card_cvv']) . "', `date_added` = NOW()");
}
public function deleteAlfabankBYPayment(int $customer_id, int $alfabankby_payment_id): void {
$this->db->query("DELETE FROM `" . DB_PREFIX . "alfabankby_payment` WHERE `customer_id` = '" . (int)$customer_id . "' AND `alfabankby_payment_id` = '" . (int)$alfabankby_payment_id . "'");
}
public function charge(int $customer_id, int $order_id, float $amount, int $alfabankby_payment_id = 0): string {
return $this->config->get('payment_alfabankby_payment_response');
}
public function storeGatewayOrder($data) {
$this->db->query("INSERT INTO `" . DB_PREFIX . "alfabankby_order` SET `order_id` = '" . (int)$data['order_id'] . "', `gateway_order_reference` = '" . $this->db->escape($data['gateway_order_reference']) . "', `currency` = '" . $this->db->escape($data['currency']) . "', `order_amount` = '" . (float)$data['order_amount'] . "', `order_amount_deposited` = '" . (float)$data['order_amount_deposited'] . "', `status_deposited` = '" . (int)$data['status_deposited'] . "', `date_added` = NOW(), `date_updated` = NOW()");
}
}
